-- Test add_amenity_feature
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, public;

select has_function('camper', 'add_amenity_feature', array['integer', 'text', 'text', 'text']);
select function_lang_is('camper', 'add_amenity_feature', array['integer', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'add_amenity_feature', array['integer', 'text', 'text', 'text'], 'integer');
select isnt_definer('camper', 'add_amenity_feature', array['integer', 'text', 'text', 'text']);
select volatility_is('camper', 'add_amenity_feature', array['integer', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'add_amenity_feature', array ['integer', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_amenity_feature', array ['integer', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_amenity_feature', array ['integer', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_amenity_feature', array ['integer', 'text', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate amenity_feature cascade;
truncate amenity cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (3, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into amenity (amenity_id, company_id, label, name)
values (6, 1, 'A1', 'Amenity A1')
     , (7, 2, 'A1', 'Amenity A1')
;

select lives_ok(
	$$ select add_amenity_feature(1, 'A1', 'wifi', 'Feature 1') $$,
	'Should be able to add an feature to the first amenity'
);

select lives_ok(
	$$ select add_amenity_feature(2, 'A1', 'information', 'Feature 2') $$,
	'Should be able to add an feature to the second amenity'
);

select throws_ok(
	$$ select add_amenity_feature(1, 'A2', 'baby', 'Nope') $$,
	'23503', 'insert or update on table "amenity_feature" violates foreign key constraint "amenity_feature_amenity_id_fkey"',
	'Should raise an error if the label is not valid.'
);

select throws_ok(
	$$ select add_amenity_feature(3, 'A1', 'baby', 'Nope') $$,
	'23503', 'insert or update on table "amenity_feature" violates foreign key constraint "amenity_feature_amenity_id_fkey"',
	'Should raise an error if the company is not valid.'
);


select bag_eq(
	$$ select amenity_id, icon_name, name from amenity_feature $$,
	$$ values (6, 'wifi', 'Feature 1')
	        , (7, 'information', 'Feature 2')
	$$,
	'Should have added all two amenity features'
);

select *
from finish();

rollback;
